/**
* Preferences for the mailRoute extension
*
* @author Christian Weiske <cweiske@cweiske.de>
*/
if (!pref) {
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
}

var mailRoutePreferences = {
    chooseFolder: function ()
    {
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"]
                           .createInstance(nsIFilePicker);
/*
    var bundlePreferences = document.getElementById("bundlePreferences");
    var title = bundlePreferences.getString("chooseDownloadFolderTitle");
*/
        var title = "Choose own icon directory";
        fp.init(window, title, nsIFilePicker.modeGetFolder);

        const nsILocalFile = Components.interfaces.nsILocalFile;
        var dirField = document.getElementById("mailroute.ownIconDir");
        if (dirField.value) {
            try {
                fp.displayDirectory = nsiLocalFile.initWithPath(dirField.value);
            } catch (e){}
        }
        fp.appendFilters(nsIFilePicker.filterAll);
        if (fp.show() == nsIFilePicker.returnOK) {
            var file = fp.file.QueryInterface(nsILocalFile);
            dirField.value = "file://localhost" + file.path + "/";
        }
    },//chooseFolder: function ()



    loadPreferences: function()
    {

        document.getElementById("mailroute.hideFrom").checked    = mailRoute.getBooleanPref("mail.mailRoute.hideFrom", false);

        document.getElementById("mailroute.hideRoute").checked   = mailRoute.getBooleanPref("mail.mailRoute.hideRoute", false);
        var nSize                                                = mailRoute.getIntPref    ("mail.mailRoute.routeIconSize", mailRoute.nRouteIconSize);
        document.getElementById("mailroute.routeIconSize").value = nSize + "x" + nSize;

        document.getElementById("mailroute.cacheIcons").checked  = mailRoute.getBooleanPref("mail.mailRoute.cacheIcons", true);
        document.getElementById("mailroute.ownIconDir").value    = mailRoute.getCharPref   ("mail.mailRoute.ownIconDir"   , null);
    },//loadPreferences: function()



    savePreferences: function()
    {
        mailRoutePreferences.setBooleanPref("mail.mailRoute.hideFrom"  , document.getElementById("mailroute.hideFrom").checked);

        mailRoutePreferences.setBooleanPref("mail.mailRoute.hideRoute" , document.getElementById("mailroute.hideRoute").checked);
        mailRoutePreferences.setIntPref("mail.mailRoute.routeIconSize" , parseInt(document.getElementById("mailroute.routeIconSize").value));

        mailRoutePreferences.setBooleanPref("mail.mailRoute.cacheIcons", document.getElementById("mailroute.cacheIcons").checked);
        mailRoutePreferences.setCharPref   ("mail.mailRoute.ownIconDir", document.getElementById("mailroute.ownIconDir").value);
    },//savePreferences: function()



    /**
    *  saves the given preference setting
    */
    setBooleanPref: function(strName, bValue)
    {
        pref.setBoolPref(strName, bValue);
    },//setBooleanPref: function(strName, bValue)



    /**
    *  saves the given preference setting
    */
    setIntPref: function(strName, nValue)
    {
        pref.setIntPref(strName, nValue);
    },//setIntPref: function(strName, nValue)



    /**
    *  saves the given preference setting
    */
    setCharPref: function(strName, strValue)
    {
        pref.setCharPref(strName, strValue);
    }//setCharPref: function(strName, strValue)

}//var mailRoutePreferences
